class CKY:
    def __init__(self, root, rule_param):
        self._root = root
        self._rule_param = rule_param
        self._nt_list = self._rule_param.get_nt_list()

    def _initialize_pi(self, sentence):
        i = 0
        for xi in sentence:
            i += 1
            self._nt_list_at[i, i] = []
            for X in self._nt_list:
                q = self._rule_param.get_q_uni(X, xi)
                if q != 0.0:
                    self._nt_list_at[i, i].append(X)
                    self._pi[i, i, X] = q
                    self._bp[i, i, X] = []

    def parse(self, sentence):
        _nt_list_at = {}
        _pi = {}
        _bp = {}
        def make_tree(pi_idx):
            i, j, X = pi_idx
            bp = _bp[pi_idx]
            if len(bp) == 0:
                return [X, sentence[i - 1]]
            else:
                return [X, make_tree(bp[0]), make_tree(bp[1])]

        def _initialize_pi():
            i = 0
            for xi in sentence:
                i += 1
                _nt_list_at[i, i] = []
                for X in self._nt_list:
                    q = self._rule_param.get_q_uni(X, xi)
                    if q != 0.0:
                        _nt_list_at[i, i].append(X)
                        _pi[i, i, X] = q
                        _bp[i, i, X] = []

        _initialize_pi()
        sen_len = len(sentence)
        for l in xrange(1, sen_len):
            for i in xrange(1, sen_len - l + 1):
                j= i + l
                _nt_list_at[i, j] = []
                for X in self._nt_list:
                    max_pi = 0.0
                    for s in xrange(i, j):
                        for Y in _nt_list_at[i, s]:
                            for Z in _nt_list_at[s+1, j]:
                                cur_pi = self._rule_param.get_q_em(X, Y, Z) * _pi[i, s, Y] * _pi[s+1, j, Z]
                                if cur_pi > max_pi:
                                    max_pi = cur_pi
                                    pi_idx1 = (i, s, Y)
                                    pi_idx2 = (s+1, j, Z)
                    if max_pi > 0.0:
                        _nt_list_at[i, j].append(X)
                        _pi[i, j, X] = max_pi
                        _bp[i, j, X] = [pi_idx1, pi_idx2]
        return make_tree((1, sen_len, self._root))
