import sys
import json
from trainiter import TrainDataIter
from rarelist import RareList

RARE_TAG = '_RARE_'

def replace_rares(fn_train, rare_list):
    """
    Replaces rare words in fn_train file with _RARE_
    and prints the new one to stdout
    """
    def parse_sentence(org):
        list_len = len(org)
        if list_len == 2:
            if rare_list.is_rare(org[1]):
                return [org[0], RARE_TAG]
            else:
                return org
        elif list_len == 3:
            return [org[0], parse_sentence(org[1]), parse_sentence(org[2])]
        else:
            raise ValueError('sentence tree list have {} items: must be 2 or 3'.format(list_len))
    for old_sentence in TrainDataIter(fn_train):
        new_sentence = parse_sentence(old_sentence)
        print json.dumps(new_sentence)
    
def main():
    if len(sys.argv) >= 2:
        fn_train = sys.argv[1]
    else:
        fn_train = 'parse_train.dat'
    rare_list = RareList(fn_train)
    replace_rares(fn_train, rare_list)
    
if __name__ == "__main__":
    main()
    